"""GLiCID spawner module."""

from batchspawner import SlurmSpawner
from traitlets import Unicode, default

from .form import options_form, options_from_form


class GlicidSpawner(SlurmSpawner):
    """Glicid SLURM Spawner."""

    glicid_singleuser_cmd = Unicode(
        'glicid-spawner-singleuser',
        help='Glicid spawner singleuser command.',
    ).tag(config=True)

    @default('batchspawner_singleuser_cmd')
    def _batchspawner_singleuser_cmd_default(self):
        return self.glicid_singleuser_cmd

    def options_form(self) -> str:
        """JupyterHub rendered form template."""
        return options_form(self.user.name)

    def options_from_form(self, formdata) -> dict:
        """Export options from form."""
        return options_from_form(formdata)
